//
//|                                                                        MLP |
//|                                                           version   1.00.00|
//|                                                Copyright 2011, JQS aka Joo |
//|                                           http://www.mql4.com/ru/users/joo |
//|                                        https://login.mql5.com/ru/users/joo |
//

#include "stdafx.h"
#include "math.h"

/*
_DLLAPI int __stdcall <FF()>
*/


//
int     InCount  = 0;// -    
int     HL1Count = 0;// -     
int     HL2Count = 0;// -     
int     OutCount = 0;// -    

double *HiLayer1 = new double[0];//    
double *HiLayer2 = new double[0];//    
double *OutLayer = new double[0];//   

int     u     =0;//    
int     i     =0;//    
int     cnt_W =0;//  
//


//
//   
_DLLAPI int __stdcall InitMLP(
                             int InNeuronCount, //     
                             int HiNeuronCount1,//      
                             int HiNeuronCount2,//      
                             int OutNeuronCount //     
                             )
{
  InCount  = InNeuronCount;
  HL1Count = HiNeuronCount1;
  HL2Count = HiNeuronCount2;
  OutCount = OutNeuronCount;

  HiLayer1= new double[HL1Count];
  HiLayer2= new double[HL2Count];

  return(InCount *HL1Count+HL1Count+
         HL1Count*HL2Count+HL2Count+
         HL2Count*OutCount+OutCount);
}
//


//
//  
_DLLAPI void __stdcall MLP(
                          int     WeightAddress, //    ,    
                          double *InLayer,       //   
                          double *Weight,        //   
                          double *OutLayer       //   
                          )
{
  cnt_W=WeightAddress;//

  //////////////////////////////////////////////////////////////////////////////
  //-------------------   ---------------------------
  //    : (+b)
  for ( u=0;u<HL1Count;u++ )
  {
    HiLayer1[u]=Weight[cnt_W]; cnt_W++;
  }

  //       :
  // (+w1*x1+...+wn*xn)   
  for ( u=0;u<HL1Count;u++ )
    for ( i=0;i<InCount;i++ )
    {
      HiLayer1[u]+=InLayer[i]*Weight[cnt_W]; cnt_W++;
    }

  //      
  for ( u=0;u<HL1Count;u++ )
    HiLayer1[u]=(2.0/(1.0+exp(-HiLayer1[u]*7.0)))-1.0;
  //////////////////////////////////////////////////////////////////////////////

  //////////////////////////////////////////////////////////////////////////////
  //-------------------   ---------------------------
  //    : (+b)
  for ( u=0;u<HL2Count;u++ )
  {
    HiLayer2[u]=Weight[cnt_W]; cnt_W++;
  }

  //       :
  // (+w1*x1+...+wn*xn)   
  for ( u=0;u<HL2Count;u++ )
    for ( i=0;i<HL1Count;i++ )
    {
      HiLayer2[u]+=HiLayer1[i]*Weight[cnt_W]; cnt_W++;
    }

  //      
  for ( u=0;u<HL2Count;u++ )
    HiLayer2[u]=(2.0/(1.0+exp(-HiLayer2[u]*7.0)))-1.0;
  //////////////////////////////////////////////////////////////////////////////

  //////////////////////////////////////////////////////////////////////////////
  //---------------------  -------------------------------
  //    : (+b)
  for (u=0;u<OutCount;u++)
  {
    OutLayer[u]=Weight[cnt_W]; cnt_W++;
  }

  //       :
  // (+w1*x1+...+wn*xn)   
  for (u=0;u<OutCount;u++)
    for (i=0;i<HL2Count;i++)
    {
      OutLayer[u]+=HiLayer2[i]*Weight[cnt_W]; cnt_W++;
    }

  //      
  for (i=0;i<OutCount;i++)
    OutLayer[i]=(2.0/(1.0+exp(-OutLayer[i]*7.0)))-1.0;

  //delete [] HiLayer1;
  //delete [] HiLayer2;
}
//