//+----------------------------------------------------------------------------+
//|                                                 MLP MS compiler nonOpt.mq5 |
//|                                                Copyright 2011, JQS aka Joo |
//|                                           http://www.mql4.com/ru/users/joo |
//|                                        https://login.mql5.com/ru/users/joo |
//
#property copyright "Copyright 2011, JQS aka Joo"
#property link      "http://www.mql5.com"
#property version   "1.00"
#property script_show_inputs

#import "2_MLP_MS_compiler_nonOpt.dll"                     
int InitMLP(
           int InNeuronCount, //     
           int HiNeuronCount1,//      
           int HiNeuronCount2,//      
           int OutNeuronCount //     
           );
           
void MLP(
        int     WeightAddress, //    ,    
        double &InLayer [],    //   
        double &Weight  [],    //   
        double &OutLayer[]     //   
        );
#import



//
//--- input parameters
input int InputNCount_P = 80;
input int H1NCount_P    = 100;
input int H2NCount_P    = 100;
input int OutNCount_P   = 10;
input int Iteration_P   = 200000;
//

//
void OnStart()
{
  double          InLayer_P [];
  ArrayResize    (InLayer_P,InputNCount_P);
  ArrayInitialize(InLayer_P,0.0);

  double          Weight_P  [];
  ArrayResize    (Weight_P, 
                  InitMLP(InputNCount_P,H1NCount_P,H2NCount_P,OutNCount_P));
  ArrayInitialize(Weight_P,0.0);

  double          OutLayer_P[];
  ArrayResize    (OutLayer_P, OutNCount_P);
  ArrayInitialize(OutLayer_P,0.0);

  int endTime=0;
  int startTime=(int)GetTickCount();

  //////////////////////////////////////////////////////////////////////////////
  for (int k=0;k<Iteration_P;k++)
  {
    MLP(0,InLayer_P,Weight_P,OutLayer_P);
  }
  //////////////////////////////////////////////////////////////////////////////

  endTime=(int)GetTickCount()-startTime;
  double endTimeD=(double)endTime/1000.0;
  Print(" 2  ",Iteration_P,"  - ",NormalizeDouble(endTimeD,3)," .   ");
}
//